/* extractNetwork.cc */

/*

[$B%W%m%0%i%`L>(B]

extractNetwork.cc -- plain format V.2 $BBP1~(B --

[$B2?$r$9$k%W%m%0%i%`$+(B]

extractNetwork.cc $B$O!"(Bplain format V.2 $B2OF;LV%G!<%?%;%C%H$+$i!"(B
$B;XDj$5$l$?2OF;6hJ,$h$j>e$NItJ,?e7O$N%G!<%?%;%C%H$r:n@.$9$k%W%m%0%i%`$G$9!#(B

[$B;H$$J}(B]

(1) $B0z?t$J$7$G5/F0$9$k>l9g(B :

% extractNetwork
# Plain format file name (V.2) : PlainFormatFileName
# Output file name : ExtractNetworkFileName
# Segment number : SegmentNumber

(2) $B0z?t$D$-$G5/F0$9$k>l9g(B :

% extractNetwork PlainFormatFileName ExtractNetworkFileName
 SegmentNumber

	o PlainFormatFileName : plain format V.2 $B2OF;LV%U%!%$%k(B($BF~NO%U%!%$%k(B)
	$BL>(B
	o ExtractNetworkFileName  : $BCj=P$5$l$?(B plain format V.2 $B2OF;LV%U%!%$(B
	$B%k(B($B=PNO%U%!%$%k(B)$BL>(B
	o SegmentNumber : $B2OF;6hJ,HV9f(B($B$3$N2OF;6hJ,$h$j>e$NItJ,?e7O$N%G!<(B
	$B%?$,Cj=P$5$l$^$9!#(B)

[$BF~NO%U%!%$%k$N%U%)!<%^%C%H(B]

plain format V.2

[$B=PNO%U%!%$%k$N%U%)!<%^%C%H(B]

plain format V.2

[$B%3%s%Q%$%k(B]

% make

[$B$=$NB>(B]

$B=PNO%U%!%$%k$K=q$-=P$5$l$kC<E@HV9f$d2OF;6hJ,HV9f$O!"F~NO%U%!%$%k(B
$B$K=q$+$l$F$$$kHV9f$,$=$N$^$^J]B8$5$l$^$9!#?7$?$KHV9f$r?6$jD>$9(B
$B$H$$$&$3$H$O$7$F$$$^$;$s!#(B

*/

#include <iostream.h>
#include <fstream.h>
#include <strstream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <assert.h>

#include "khslist.h"	// $B%F%s%W%l!<%H%/%i%9(B KhSListDynamic $B$NDj5A(B
#include "khslist.cc"
#include "khboolean.h"
#include "khsimple.h"
#include "kherror.h"
#include "khstr.h"

class PointData {
	int pnum;					// $B2OF;E@HV9f(B
	int pos;					// $B0LCV>pJs(B
	double x;					// x $B:BI8(B
	double y;					// y $B:BI8(B
	double z;					// z $B:BI8(B
	double w;					// $B2OF;I}(B

  public:
	void Init(int p, int dpos, double dx, double dy, double dz, double
			  dw) { pnum = p;  pos = dpos; x = dx; y = dy; z = dz; w =
					dw; }

	void operator = (const PointData& pd) { pnum = pd.pnum;  pos =
											pd.pos; x = pd.x; y = pd.y;
											z = pd.z; w = pd.w; }
	int Pnum(void) { return pnum; }
	int Pos(void) { return pos; }
	double X(void) { return x; }
	double Y(void) { return y; }
	double Z(void) { return z; }
	double W(void) { return w; }

//	friend ofstream& operator<<(ofstream& os, const PointData& pd);
	friend ofstream& operator<<(ofstream& os, const PointData& pd);
};

ofstream& operator<<			// PointData $B7?%G!<%?$N=PNO(B
(
	ofstream& os,				// $B=PNO%9%H%j!<%`(B
 	const PointData& pd			// Point $B7?%G!<%?(B
)
{
	os << abs(pd.pnum) << " " << pd.x << " "  
	   << pd.y << " " << pd.z << " " << pd.pos;

	return os;
}

template class KhSListDynamic<PointData>;

class Segment {

// $B%G!<%?%a%s%P(B
  protected:
	int gx;						// $B%0%j%C%IHV9f(B x
	int gy;						// $B%0%j%C%IHV9f(B y

	int snum;					// $B2OF;6hJ,HV9f(B
	int ends[2];				// $B2OF;6hJ,$r9=@.$9$kC<E@$NHV9f(B

	KhSListDynamic<PointData> pdList;

	KhBoolean visited;			// YES $B$J$i8!:w:Q(B, NO $B$J$i$^$@(B

  public:
	Segment(void) { visited = NO; }
	~Segment(void) { pdList.Erase(); }

	void RecGridNum(int x, int y) { gx = x; gy = y; }
	void RecSnum(int n) { snum = n; }
	void RecEnd0(int e0) { ends[0] = e0; }
	void RecEnd1(int e1) { ends[1] = e1; }
	int SegNum(void) { return snum; }
	int End0(void) { return ends[0]; }

	// visited $B$rJV$9(B
	KhBoolean IsVisited(void) { return visited; }

	// visited $B$r(B YES $B$K$9$k(B
	void Visited(void) { visited = YES; }

	// ends $B$rJV$9(B
	void Ends(int* b) {	b[0] = ends[0]; b[1] = ends[1]; }

	// a[0], a[1] $B$H$$$&C<E@$r;}$C$F$$$k$+$I$&$+(B
	KhBoolean IsThere(int* a);

	// a $B$H$$$&C<E@$r;}$C$F$$$k$+$I$&$+(B
	KhBoolean IsThere(int a);

	// PointData $B$r(B pdList $B$KDI2C$9$k(B
	void AddPoint(int p, int pos, 
				  double x, double y, double z, double w);

	void GetEndPoints(PointData& epa, PointData& epb);

	friend ofstream& operator<<(ofstream& os, Segment s);
	friend ostream& operator<<(ostream& os, Segment s);

	void operator = (const Segment& s)
	{
		gx = s.gx; gy = s.gy; snum = s.snum;
		ends[0] = s.ends[0]; ends[1] = s.ends[1]; 
		pdList = s.pdList; visited = s.visited;
	}
};

KhBoolean Segment::IsThere		// a[0],a[1] $B$H$$$&C<E@$r;}$D$+(B
(
	int* a						// $BN>C<E@HV9f(B
)
{
	int i, j;
	for (i = 0; i < 2; i++) {
		for (j = 0; j < 2; j++) {
			if (abs(a[i]) == abs(ends[j])) return YES;
		}
	}
	return NO;
}

KhBoolean Segment::IsThere		// a $B$H$$$&C<E@$r;}$D$+(B
(
	int a						// $BC<E@HV9f(B
)
{
	int i;
	for (i = 0; i < 2; i++) {
		if (abs(a) == abs(ends[i])) return YES;
	}
	return NO;
}

void Segment::AddPoint			// $B2OF;E@>pJs$r(B pdList $B$KDI2C$9$k(B
(
	int p,						// $B2OF;E@HV9f(B
	int pos,					// $B0LCV>pJs(B
	double x,					// x $B:BI8(B
	double y,					// y $B:BI8(B
	double z,					// z $B:BI8(B
 	double w					// $B2OF;I}(B
)
{
	PointData pd;
	pd.Init(p, pos, x, y, z, w);
	pdList.Append(pd);
}

void Segment::GetEndPoints
(
	PointData& epa, 
 	PointData& epb
)
{
	pdList.ToHead();
	epa = pdList.Get();

	// pdList $B$N:G8e$^$G?J$`(B
	while (pdList.ToNext() == YES) ;

	epb = pdList.Get();
}

ofstream& operator<<			// Segment $B7?%G!<%?$N=PNO(B
(
	ofstream& os,				// $B=PNO%9%H%j!<%`(B
 	Segment s					// Segment $B7?%G!<%?(B
)
{
	KhBoolean r;
	PointData p;
	for (r = s.pdList.ToHead(); r == YES; r = s.pdList.ToNext()) {
		p = s.pdList.Get();
		os << s.gx << " " << s.gy << " "  
		   << p.Pnum() << " " << s.snum << " " << p.Pos() << " " 
		   << p.X() << " " << p.Y() << " " << p.Z() << " "
		   << p.W() << endl;
	}

	return os;
}

ostream& operator<<			// Segment $B7?%G!<%?$N=PNO(B
(
	ostream& os,				// $B=PNO%9%H%j!<%`(B
 	Segment s					// Segment $B7?%G!<%?(B
)
{
	KhBoolean r;
	PointData p;
	for (r = s.pdList.ToHead(); r == YES; r = s.pdList.ToNext()) {
		p = s.pdList.Get();
		os << s.gx << " " << s.gy << " " 
		   << p.Pnum() << " " << s.snum << " " << p.Pos() << " " 
		   << p.X() << " " << p.Y() << " " << p.Z() << " "
		   << p.W() << endl;
	}

	return os;
}

template class KhSListDynamic<Segment>;

class GridBox {

// $B%G!<%?%a%s%P(B
  protected:
	int segnum;				// $B;XDj$5$l$?2OF;6hJ,HV9f(B
	int n_seg;				// $B2OF;6hJ,$N?t(B
	int n_ep;				// $BC<E@$N?t(B
	Segment* seg;			// $B%/%i%9(B Segment $B$NG[Ns(B
	KhBoolean** adjacent;	// $B@\B39TNs(B
	KhSListDynamic<Segment> segList;	// $BCj=P$7$?2OF;6hJ,$N%G!<%?$r5-(B
										// $B21$9$k%j%9%H(B
	KhSListDynamic<PointData> epList;	// $BC<E@$N%j%9%H(B
	KhString comment,			   // [Comment]
			 dataFormatName,	   // [Data Format Name]
			 coordinateSystem,	   // [Coordinate System]
			 mapNumber,			   // [Map Number]
			 referenceCoordinates, // [Reference Coordinates]
			 verticesOfTheMap;	   // [Vertices of the Map]

	ifstream pf;		// $BF~NO%U%!%$%kL>(B
	KhString fname;		// $B=PNO%U%!%$%kL>(B

// $B%a%s%P4X?t(B
  public:
	GridBox(char* in, char* out, int s);	// $B%3%s%9%H%i%/%?(B
	~GridBox(void);							// $B%G%9%H%i%/%?(B

	void ReadDataSection(void);	// [Data] $BIt$rFI$`(B
	void MakeAdjacent(void);	// $B@\B39TNs$r:n@.$9$k(B
	void ExtractNetwork(void);	// $BItJ,?e7O$rCj=P$9$k(B
	void WriteData(void);		// $B%G!<%?$r=PNO$9$k(B

  protected:
	void Visit(int i);			// $B:F5"4X?t(B
};

GridBox::GridBox	// GridBox $B$N%G%U%)%k%H%3%s%9%H%i%/%?(B
(
 char* in,			// $BF~NO%U%!%$%kL>(B
 char* out,			// $B=PNO%U%!%$%kL>(B
 int s				// $B;XDj$5$l$?2OF;6hJ,HV9f(B
 )
: pf(in)
{
	// $B;XDj$5$l$?2OF;6hJ,$N2OF;6hJ,HV9f$r5-21(B
	segnum = s;

	// $B%3%a%s%H$N=q$-9~$_(B
	comment = "[Comment]\n";
	comment += "This dataset was produced by extractNetwork from ";
	comment += in;
	comment += ".\n";

	// $B=PNO%U%!%$%kL>$r<u$1<h$k(B
	fname = out;

	int i, j;
	KhString buf;

	while (getline(pf, buf)) {

		// [Data] $BIt$K$J$C$?$i(B break
		if (buf == "[Data]") break;

		// [Comment] $BIt$r%3%T!<$9$k(B
		if (buf == "[Comment]") {
			while (getline(pf, buf) && buf[0] != '[') {
				comment += buf;
				comment += '\n';
			}
		}

		// [Data Format Name] $BIt$r%3%T!<$9$k(B
		if (buf == "[Data Format Name]") {
			dataFormatName = buf;
			dataFormatName += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				dataFormatName += buf;
				dataFormatName += '\n';
			}
		}

		// [Coordinate System] $BIt$r%3%T!<$9$k(B
		if (buf == "[Coordinate System]") {
			coordinateSystem = buf;
			coordinateSystem += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				coordinateSystem += buf;
				coordinateSystem += '\n';
			}
		}

		// [Map Number] $BIt$r%3%T!<$9$k(B
		if (buf == "[Map Number]") {
			mapNumber = buf;
			mapNumber += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				mapNumber += buf;
				mapNumber += '\n';
			}
		}

		// [Reference Coordinates] $BIt$r%3%T!<$9$k(B
		if (buf == "[Reference Coordinates]") {
			referenceCoordinates = buf;
			referenceCoordinates += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				referenceCoordinates += buf;
				referenceCoordinates += '\n';
			}
		}

		// [Vertices of the Map] $BIt$r%3%T!<$9$k(B
		if (buf == "[Vertices of the Map]") {
			verticesOfTheMap = buf;
			verticesOfTheMap += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				verticesOfTheMap += buf;
				verticesOfTheMap += '\n';
			}
		}

		// n_seg $B$r<hF@(B
		if (buf == "[Number of River Segments]") {
			getline(pf, buf);
			istrstream istr(buf);
			istr >> n_seg;
		}

	}

	assert(n_seg > 0);

	// $BG[Ns(B seg $B$r3NJ](B
	seg = new Segment[n_seg];

	// $BG[Ns(B adjacent $B$r3NJ](B
	adjacent = new KhBoolean*[n_seg];
	for (i = 0; i < n_seg; i++) {
		adjacent[i] = new KhBoolean[n_seg];
		for (j = 0; j < n_seg; j++) adjacent[i][j] = NO;
	}
}

GridBox::~GridBox				// GridBox $B$N%G%9%H%i%/%?(B
(
	void						// $B0z?tL5$7(B
)
{
	delete [] seg;

	int i;
	for (i = 0; i < n_seg; i++) delete [] adjacent[i];
	delete [] adjacent;
}

void GridBox::ReadDataSection	// $BF~NO%U%!%$%k$N(B [Data] $BIt$rFI$`(B
(
	void						// $B0z?tL5$7(B
)
{
	int ix, iy;		// $B%0%j%C%IHV9f(B
	int pnum;		// $BC<E@HV9f(B
	int snum;		// $B2OF;6hJ,HV9f(B
	int pos;		// $BC<E@0LCV>pJs(B
	double x, y, z;	// $B:BI8(B
	double w;		// $B2OF;I}(B
	KhString buf;

	KhBoolean inside = NO; // YES : $B2OF;6hJ,$NCf(B
						   // NO  : $B2OF;6hJ,$+$i=P$?(B

	int segCount = -1;	   // $B2OF;6hJ,$N%+%&%s%?(B

	while (getline(pf, buf)) {
		if (buf[0] == '#') continue; // $B%3%a%s%H9T$OFI$_Ht$P$9(B

		// $BJ8;zNs%9%H%j!<%`$K%G!<%?$rFI$_9~$`(B
		istrstream iss(buf, 256);
		iss >> ix >> iy >> pnum >> snum >> pos
			>> x >> y >> z >> w;

		// $B?7$?$J2OF;6hJ,$KF~$C$?(B
		if (inside == NO && pos >= 0) {
			inside = YES;
			segCount++;
			seg[segCount].RecGridNum(ix, iy);
			seg[segCount].RecSnum(snum);
			seg[segCount].RecEnd0(pnum);
		}
		// $B0l$D$N2OF;6hJ,$,=*$C$?(B
		else if (inside == YES && pos >= 0) {
			inside = NO;
			seg[segCount].RecEnd1(pnum);
		}

		// $B2OF;E@$N%G!<%?$r%j%9%H$K<}O?$9$k(B
		seg[segCount].AddPoint(pnum, pos, x, y, z, w);
	}

// 	// for debugging
// 	int i;
// 	for (i = 0; i < n_seg; i++) cout << seg[i];

}

void GridBox::MakeAdjacent		// $B@\B39TNs$r:n@.$9$k(B
(
	void
)
{
	int i, j;
	int e[2];
	for (i = 0; i < n_seg; i++) {
		seg[i].Ends(e);
		for (j = 0; j < n_seg; j++) {
			if (j == i) continue;
			if (seg[j].IsThere(e) == YES) {
				adjacent[i][j] = YES;
			}
		}
	}

	// $B;XDj$5$l$?2OF;6hJ,$N2<N.B&$N@\B3$r@Z$k(B
	for (i = 0; i < n_seg; i++) {
		if (segnum == abs(seg[i].SegNum())) break;
	}
	e[0] = seg[i].End0();
	for (j = 0; j < n_seg; j++) {
		if (j == i) continue;
		if (seg[j].IsThere(e[0]) == YES) {
			adjacent[i][j] = NO;
			adjacent[j][i] = NO;
		}
	}

	// for debugging
//	for (i = 0; i < n_seg; i++) {
//		for (j = 0; j < n_seg; j++) {
//			cout << setw(3) << adjacent[i][j];
//		}
//		cout << endl;
//	}

}

void GridBox::ExtractNetwork	// $B;XDj$5$l$?ItJ,?e7O$rCj=P$9$k(B
(
	void						// $B0z?tL5$7(B
)
{
	int i;

	// $B;XDj$5$l$?2OF;6hJ,$h$j>eN.$N2OF;6hJ,$r%j%9%H$K5-21$9$k(B
	for (i = 0; i < n_seg; i++) {
		if (segnum == abs(seg[i].SegNum())) break;
	}
	Visit(i);

	KhBoolean r, p, fepa, fepb;
	Segment s;
	PointData epa, epb, ep;

	// $B2OF;6hJ,$N%j%9%H$+$iC<E@$K4X$9$k%G!<%?$r:n@.$9$k(B
	for (r = segList.ToHead(); r == YES; r = segList.ToNext()) {
		// $B2OF;6hJ,$r0l$D<h$j=P$9(B
		s = segList.Get();
		// $B$=$N2OF;6hJ,$NC<E@$r(B epa, epb $B$K%3%T!<$9$k(B
		s.GetEndPoints(epa, epb);

		// epa, epb $B$,(B epList $B$KEPO?$5$l$F$$$k$+%A%'%C%/(B
		fepa = fepb = NO;
		for (p = epList.ToHead(); p == YES; p = epList.ToNext()) {
			ep = epList.Get();
			if (fepa == NO && 
				abs(ep.Pnum()) == abs(epa.Pnum())) 
				fepa = YES;
			if (fepb == NO && 
				abs(ep.Pnum()) == abs(epb.Pnum())) 
				fepb = YES;
			if (fepa == YES && fepb == YES) break;
		}

		// epa, epb $B$r(B epList $B$KEPO?(B
		if (fepa == NO) epList.Append(epa);
		if (fepb == NO) epList.Append(epb);
	}
	n_ep = epList.GetCount();
}

void GridBox::Visit		// $B2OF;6hJ,(B i $B$rK,$l$k(B
(
	int i				// $B2OF;6hJ,HV9f(B
)
{
	// i $B$rK,$l$?%U%i%C%0$rN)$F$k(B
	seg[i].Visited();
	// i $B$r(B segList $B$KDI2C$9$k(B
	segList.Append(seg[i]);

	int j;

	// $B2OF;6hJ,(B i $B$H$D$J$,$C$F$$$k2OF;6hJ,(B j $B$rC5$9(B
	for (j = 0; j < n_seg; j++) {
		// $B$"$C$?(B
		if (seg[j].IsVisited() == NO && adjacent[i][j] == YES) {
			Visit(j);

// 			// for debugging
// 			cout << j << endl;
		}
	}
}

void GridBox::WriteData			// $B%G!<%?$r=PNO$9$k(B
(
	void						// $B0z?tL5$7(B
)
{
	ofstream ofs(fname);

	// [Comment] $BIt$+$i(B [Vertices of the Map] $BIt$^$G(B
	ofs << comment << dataFormatName << coordinateSystem 
		<< mapNumber << referenceCoordinates 
		<< verticesOfTheMap;

	// [Number of End Points] $BIt(B
	ofs << "[Number of End Points]" << endl 
		<< n_ep << endl;

	// [Data of End Points] $BIt(B
	ofs << "[Data of End Points]" << endl;
	KhBoolean r;
	PointData pd;
	for (r = epList.ToHead(); r == YES; r = epList.ToNext()) {
		pd = epList.Get();
		ofs << pd << endl;
	}

	n_seg = segList.GetCount();
	// [Number of River Segments] $BIt(B
	ofs << "[Number of River Segments]" << endl
		<< n_seg << endl;

	// [Data] $BIt(B
	ofs << "[Data]" << endl;
	Segment s;
	for (r = segList.ToHead(); r == YES; r = segList.ToNext()) {
		s = segList.Get();
		ofs << s;
	}
}

int main						// $B%a%$%s%W%m%0%i%`(B
(
	int argc,
 	char** argv
)
{

	KhString command;

	// argc $B$K$O(B, $B%3%^%s%IL>$H0z?t$N8D?t$,F~$j$^$9!#0z?t$,0l8D$b$J$$(B
	// $B$H$-!$(Bargc $B$K$O(B 1 $B$,F~$j$^$9!#(B

	assert (argc == 1 || argc == 4);

	// $BF~=PNO%U%!%$%k$NL>A0$r<hF@$9$k(B
	char in[256], out[256];
	int segnum;
	if (argc == 1) {
		cout << "# Plain format file name (V.2) : ";
		cin >> in;
		cout << "# Output file name : ";
		cin >> out;
		cout << "# Segment number : ";
		cin >> segnum;
	}
	else {
		istrstream istri(argv[1]);
		istri >> in;
		istrstream istro(argv[2]);
		istro >> out;
		istrstream istrs(argv[3]);
		istrs >> segnum;
	}

	GridBox gb(in, out, segnum);

	// $BF~NO%U%!%$%k(B $B$N(B[Data]$BIt$r(B $B%/%i%9(B Segment $B$NG[Ns$KFI$_9~$`(B
	gb.ReadDataSection();

	// $B@\B39TNs$r:n@.$9$k(B
	gb.MakeAdjacent();

	// $BItJ,?e7O$NCj=P(B
	gb.ExtractNetwork();

	// $B%G!<%?$N=PNO(B
	gb.WriteData();

	return 0;
}
