/* makeSubNetwork.cc */
/* $Lastupdate: Wed Dec 10 18:27:24 1997 $ */

/*

[ץ̾]

makeSubNetwork.cc ver. 2.0 -- plain format V.1,2 б --

[򤹤ץफ]

makeSubNetwork.cc ϡplain format V.1,2 ƻ֥ǡåȤ顢
ʬϤΥǡåȤץǤ

[Ȥ]

(1) ʤǵư :

% makeSubNetwork
# plain format file name (V.1,2) : PlainFormatFileName
# output file name WITHOUT extension : SubNetworkFileName

(2) Ĥǵư :

% makeSubNetwork PlainFormatFileName SubNetworkFileName

  o PlainFormatFileName : plain format V.1,2 ƻ֥ե
                          (ϥե)̾
  o SubNetworkFileName  : sub-network format V.2 ե
                          (ϥե)̾Υ١ʬ(ĥҤʤ)

    ºݤ˺ϥե̾ϡ

      SubNetworkFileName-1.snf2
      SubNetworkFileName-2.snf2
      SubNetworkFileName-3.snf2
      ...
      SubNetworkFileName-N.snf2

    Ȥʤޤ( N ʬϤο)

[ϥեΥեޥå]

plain format V.1  V.2

[ϥեΥեޥå]

sub-network format V.2

[ѥ]

% make

[¾]

ϥե˽񤭽Фüֹƻʬֹϡϥե
˽񤫤Ƥֹ椬Τޤ¸ޤʬϤȤֹ
ľȤȤϤƤޤ

*/

#include <iostream.h>
#include <fstream.h>
#include <strstream.h>
#include <iomanip.h>
#include <assert.h>
#include <stdlib.h>				// for getopt

#include "khboolean.h"
#include "khsimple.h"
#include "kherror.h"
#include "khslist.h"
#include "khslist.cc"
#include "khstr.h"
#include "nopath.h"				// for nopath

#define MAXSUBNET 256	 // ʬϤοκ

typedef double Metric;   // ɸη
typedef double ElvType;  // ɸͤ

template int KhAbsVal(int);

class Point						// ƻɽ饹
{
	int pnum;					// ƻֹ
	int pos;					// ־
	Metric x;					// x ɸ
	Metric y;					// y ɸ
	ElvType z;					// z ɸ
	double w;					// ƻ

  public:
	void Init(int p, int dpos, 
			  Metric dx, Metric dy, ElvType dz, double dw)
	{ pnum = p;  pos = dpos; x = dx; y = dy; z = dz; w = dw; }

	void operator = (const Point& pp)
	{ pnum = pp.pnum;  pos = pp.pos; 
	  x = pp.x; y = pp.y; z = pp.z; w = pp.w; }

	int Pnum(void) { return pnum; }
	int Pos(void) { return pos; }
	Metric X(void) { return x; }
	Metric Y(void) { return y; }
	ElvType Z(void) { return z; }
	double W(void) { return w; }

	friend ofstream& operator<<(ofstream& os, const Point& p);
};

ofstream& operator<<			// Point ǡν
(
	ofstream& os,				// ϥȥ꡼
 	const Point& p				// Point ǡ
)
{
	os << KhAbsVal(p.pnum) << " " << p.x << " "  
	   << p.y << " " << p.z << " " << p.pos;

	return os;
}

template class KhSListDynamic<Point>;

class Segment
{
	int gx;						// åֹ x
	int gy;						// åֹ y
//	int subnum;					// ʬֹ

	int snum;					// ƻʬֹ
	int ends[2];				// ƻʬüֹ

	KhSListDynamic<Point> plist;

	KhBoolean visited;			// YES ʤ鸡, NO ʤޤ

  public:
	Segment(void) { visited = NO; }
	~Segment(void) { plist.Erase(); }

	void RecGridNum(int x, int y) { gx = x; gy = y; }
//	void RecSubNum(int n) { subnum = n; }
	void RecSnum(int n) { snum = n; }
	void RecEnd0(int e0) { ends[0] = e0; }
	void RecEnd1(int e1) { ends[1] = e1; }

	// visited ֤
	KhBoolean IsVisited(void) { return visited; }

	// visited  YES ˤ
	void Visited(void) { visited = YES; }

	// ends ֤
	void Ends(int* b) {	b[0] = ends[0]; b[1] = ends[1]; }

	// a[0], a[1] ȤüäƤ뤫ɤ
	KhBoolean IsThere(int* a);

	// Point  plist ɲä
	void AddPoint(int p, int pos, 
				  double x, double y, double z, double w);

	void GetEndPoints(Point& epa, Point& epb);

	friend ofstream& operator<<(ofstream& os, Segment s);
	friend ostream& operator<<(ostream& os, Segment s);

	void operator = (const Segment& s)
	{
		gx = s.gx; gy = s.gy; snum = s.snum;
		ends[0] = s.ends[0]; ends[1] = s.ends[1]; 
		plist = s.plist; visited = s.visited;
	}
};

KhBoolean Segment::IsThere		// a[0],a[1] ȤüĤ
(
	int* a						// ξüֹ
)
{
	int i, j;
	for (i = 0; i < 2; i++) {
		for (j = 0; j < 2; j++) {
			if (KhAbsVal(a[i]) == KhAbsVal(ends[j])) return YES;
		}
	}

	return NO;
}

void Segment::AddPoint			// ƻ plist ɲä
(
	int p,						// ƻֹ
	int pos,					// ־
	double x,					// x ɸ
	double y,					// y ɸ
	double z,					// z ɸ
 	double w					// ƻ
)
{
	Point pp;
	pp.Init(p, pos, x, y, z, w);
	plist.Append(pp);
}

void Segment::GetEndPoints
(
	Point& epa, 
 	Point& epb
)
{
	plist.ToHead();
	epa = plist.Get();

	// plist κǸޤǿʤ
	while (plist.ToNext() == YES) ;

	epb = plist.Get();
}

ofstream& operator<<			// Segment ǡν
(
	ofstream& os,				// ϥȥ꡼
 	Segment s					// Segment ǡ
)
{
	KhBoolean r;
	Point p;
	for (r = s.plist.ToHead(); r == YES; r = s.plist.ToNext()) {
		p = s.plist.Get();
//		os << s.gx << " " << s.gy << " " << s.subnum << " " 
		os << s.gx << " " << s.gy << " "  
		   << p.Pnum() << " " << s.snum << " " << p.Pos() << " " 
		   << p.X() << " " << p.Y() << " " << p.Z() << " "
		   << p.W() << endl;
	}

	return os;
}

ostream& operator<<			// Segment ǡν
(
	ostream& os,				// ϥȥ꡼
 	Segment s					// Segment ǡ
)
{
	KhBoolean r;
	Point p;
	for (r = s.plist.ToHead(); r == YES; r = s.plist.ToNext()) {
		p = s.plist.Get();
//		os << s.gx << " " << s.gy << " " << s.subnum << " " 
		os << s.gx << " " << s.gy << " " 
		   << p.Pnum() << " " << s.snum << " " << p.Pos() << " " 
		   << p.X() << " " << p.Y() << " " << p.Z() << " "
		   << p.W() << endl;
	}

	return os;
}

template class KhSListDynamic<Segment>;

class SubNetwork
{
	int SubNetworkNumber;		// ʬֹ

	int NumberofEndPoints;		// üο
	KhSListDynamic<Point> eplist; // üΥꥹ

	int NumberofRiverSegments;	// ƻʬο
	KhSListDynamic<Segment> slist; // ƻʬΥꥹ

  public:
	// ʬϤȤ줿ƻʬΥꥹȤ򥳥ԡ
	void CopySegmentList(const KhSListDynamic<Segment>& list, int num);

	// ü˴ؤǡ
	void MakeEndPointsData(void);

	// ǡϤ
	void WriteData(KhString fname, KhString comment, 
		KhString dataFormatName, KhString coordinateSystem, 
		KhString mapNumber, KhString referenceCoordinates, 
		KhString verticesOfTheMap, int numberofSubNetworks);
};

void SubNetwork::CopySegmentList
(
	const KhSListDynamic<Segment>& list, // ʬϤȤβƻʬΥꥹ
	int num								 // ʬֹ
)
{
	// ꥹȤ򥳥ԡ
	slist = list;
	// ƻʬο NumberofRiverSegments 
	NumberofRiverSegments = slist.GetCount();
	// ʬֹ SubNetworkNumber 
	SubNetworkNumber = num;
}

void SubNetwork::MakeEndPointsData
(
	void
)
{
	KhBoolean s, p, fepa, fepb;
	Segment seg; Point epa, epb, ep;

	for (s = slist.ToHead(); s == YES; s = slist.ToNext()) {
		// ƻʬļФ
		seg = slist.Get();
		// βƻʬü epa, epb ˥ԡ
		seg.GetEndPoints(epa, epb);

		// epa, epb  eplist ϿƤ뤫å
		fepa = fepb = NO;
		for (p = eplist.ToHead(); p == YES; p = eplist.ToNext()) {
			ep = eplist.Get();
			if (fepa == NO && 
				KhAbsVal(ep.Pnum()) == KhAbsVal(epa.Pnum())) 
				fepa = YES;
			if (fepb == NO && 
				KhAbsVal(ep.Pnum()) == KhAbsVal(epb.Pnum())) 
				fepb = YES;
			if (fepa == YES && fepb == YES) break;
		}

		// epa, epb  eplist Ͽ
		if (fepa == NO) eplist.Append(epa);
		if (fepb == NO) eplist.Append(epb);
	}

	NumberofEndPoints = eplist.GetCount();
}

void SubNetwork::WriteData
(
	KhString fname,				   // ϥե̾
	KhString comment,			   // [Comment] 
 	KhString dataFormatName,	   // [Data Format Name] 
	KhString coordinateSystem,	   // [Coordinate System] 
	KhString mapNumber,	  		   // [Map Number] 
 	KhString referenceCoordinates, // [Reference Coordinates] 
	KhString verticesOfTheMap,	   // [Vertices of the Map] 
 	int numberofSubNetworks		   // [Number of Sub-networks] 
)
{
	ofstream ofs(fname);

	// [Comment]  [Vertices of the Map] ޤ
	ofs << comment << dataFormatName << coordinateSystem 
		<< mapNumber << referenceCoordinates 
		<< verticesOfTheMap;

	// [Number of End Points] 
	ofs << "[Number of End Points]" << endl 
		<< NumberofEndPoints << endl;

	// [Data of End Points] 
	ofs << "[Data of End Points]" << endl;
	KhBoolean r;
	Point p;
	for (r = eplist.ToHead(); r == YES; r = eplist.ToNext()) {
		p = eplist.Get();
		ofs << p << endl;
	}

	// [Number of River Segments] 
	ofs << "[Number of River Segments]" << endl
		<< NumberofRiverSegments << endl;

	// [Number of Sub-networks] 
	ofs << "[Number of Sub-networks]" << endl
		<< numberofSubNetworks << endl;

	// [Sub-network Number] 
	ofs << "[Sub-network Number]" << endl
		<< SubNetworkNumber << endl;

	// [Data] 
	ofs << "[Data]" << endl;
	Segment s;
	for (r = slist.ToHead(); r == YES; r = slist.ToNext()) {
		s = slist.Get();
		ofs << s;
	}
}

class GridBox
{
	int numSegment;				// Number of River Segments
	Segment* seg;				// Segment 
	KhBoolean** adjacent;		// ³

	int numSubNetwork;			// ʬϤο
	KhSListDynamic<Segment>* slist;
	SubNetwork* snary;

	KhString comment,			   // [Comment]
			 dataFormatName,	   // [Data Format Name]
			 coordinateSystem,	   // [Coordinate System]
			 mapNumber,			   // [Map Number]
			 referenceCoordinates, // [Reference Coordinates]
			 verticesOfTheMap;	   // [Vertices of the Map]

	ifstream pf;			// plain format Υե
	KhString snf2;			// Sub-Network format Υե̾
							// ١ʬ

  public:
	GridBox(char* in, char* out); // 󥹥ȥ饯
	~GridBox(void);				  // ǥȥ饯

	void ReadDataSection(void);	// [Data] ɤ
	void MakeAdjacent(void);	// ³
	void MakeSubNetwork(void);	// ʬϤФ
	void WriteData(void);		// ǡϤ

  protected:
	void Visit(int i);			// Ƶؿ
};

GridBox::GridBox		// GridBox Υǥեȥ󥹥ȥ饯
(
	char* in,			// ϥե̾
	char* out			// ϥե̾
)
: pf(in)
{
	// ϥե̾ν
	snf2 = out;
	snf2 += '-';

	// Ȥν񤭹
	comment = "[Comment]\n";
	comment += "This dataset was produced by makeSubNetwork from ";
	comment += in;
	comment += ".\n";

	int i, j;
	KhString buf;

	while (getline(pf, buf)) {

		// [Data] ˤʤä break
		if (buf == "[Data]") break;

		// [Comment] 򥳥ԡ
		if (buf == "[Comment]") {
			while (getline(pf, buf) && buf[0] != '[') {
				comment += buf;
				comment += '\n';
			}
		}

		// [Data Format Name] 񤭴
		if (buf == "[Data Format Name]") {
			dataFormatName = buf;
			dataFormatName += '\n';
			getline(pf, buf);
			// ǤʬϤȤƤ
			KhString s("sub-network format V.");
			size_t pos;
			if (buf.Find(s, pos)) {
				kherror();
				cerr << "This data set is already transformed " 
					 << "into sub-network format." << endl;
				cerr << "[Data Format Name] is [" << buf << "]"
					 << endl;
				exit(1);
			}
			dataFormatName += "sub-network format V.2\n";
		}

		// [Coordinate System] 򥳥ԡ
		if (buf == "[Coordinate System]") {
			coordinateSystem = buf;
			coordinateSystem += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				coordinateSystem += buf;
				coordinateSystem += '\n';
			}
		}

		// [Map Number] 򥳥ԡ
		if (buf == "[Map Number]") {
			mapNumber = buf;
			mapNumber += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				mapNumber += buf;
				mapNumber += '\n';
			}
		}

		// [Reference Coordinates] 򥳥ԡ
		if (buf == "[Reference Coordinates]") {
			referenceCoordinates = buf;
			referenceCoordinates += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				referenceCoordinates += buf;
				referenceCoordinates += '\n';
			}
		}

		// [Vertices of the Map] 򥳥ԡ
		if (buf == "[Vertices of the Map]") {
			verticesOfTheMap = buf;
			verticesOfTheMap += '\n';
			while (getline(pf, buf) && buf[0] != '[') {
				verticesOfTheMap += buf;
				verticesOfTheMap += '\n';
			}
		}

		// numSegment 
		if (buf == "[Number of River Segments]") {
			getline(pf, buf);
			istrstream istr(buf);
			istr >> numSegment;
		}

	}

	assert(numSegment > 0);

	//  seg 
	seg = new Segment[numSegment];

	//  adjacent 
	adjacent = new KhBoolean*[numSegment];
	for (i = 0; i < numSegment; i++) {
		adjacent[i] = new KhBoolean[numSegment];
		for (j = 0; j < numSegment; j++) adjacent[i][j] = NO;
	}
}

GridBox::~GridBox				// GridBox Υǥȥ饯
(
	void						// ̵
)
{
	delete [] seg;
	delete [] slist;
	delete [] snary;

	int i;
	for (i = 0; i < numSegment; i++) delete [] adjacent[i];
	delete [] adjacent;
}

void GridBox::ReadDataSection	//  DS  [Data] ɤ
(
	void						// ̵
)
{
	int ix, iy;		// åֹ
	int pnum;		// üֹ
	int snum;		// ƻʬֹ
	int pos;		// ü־
	double x, y, z;	// ɸ
	double w;		// ƻ
	KhString buf;

	KhBoolean inside = NO; // YES : ƻʬ
						   // NO  : ƻʬФ

	int segCount = -1;	   // ƻʬΥ

	while (getline(pf, buf)) {
		if (buf[0] == '#') continue; // ȹԤɤФ

		// ʸ󥹥ȥ꡼˥ǡɤ߹
		istrstream iss(buf, 256);
		iss >> ix >> iy >> pnum >> snum >> pos
			>> x >> y >> z >> w;

		// ʲƻʬä
		if (inside == NO && pos >= 0) {
			inside = YES;
			segCount++;
			seg[segCount].RecGridNum(ix, iy);
			seg[segCount].RecSnum(snum);
			seg[segCount].RecEnd0(pnum);
		}
		// Ĥβƻʬä
		else if (inside == YES && pos >= 0) {
			inside = NO;
			seg[segCount].RecEnd1(pnum);
		}

		// ƻΥǡꥹȤ˼Ͽ
		seg[segCount].AddPoint(pnum, pos, x, y, z, w);
	}

// 	// for debugging
// 	int i;
// 	for (i = 0; i < numSegment; i++) cout << seg[i];

}

void GridBox::MakeAdjacent(		// ³
	void
)
{
	int i, j;
	int e[2];
	for (i = 0; i < numSegment; i++) {
		seg[i].Ends(e);
		for (j = 0; j < numSegment; j++) {
			if (j == i) continue;
			if (seg[j].IsThere(e) == YES) {
				adjacent[i][j] = YES;
			}
		}
	}

	// for debugging
	for (i = 0; i < numSegment; i++) {
		for (j = 0; j < numSegment; j++) {
			cout << setw(3) << adjacent[i][j];
		}
		cout << endl;
	}
}


void GridBox::MakeSubNetwork	// ʬϤȤ˥ǡ
(
	void						// ̵
)
{
	slist = new KhSListDynamic<Segment>[MAXSUBNET];
	int i;
	numSubNetwork = 0;

	// ޤƤʤ seg õ
	for (i = 0; i < numSegment; i++) {
		if (seg[i].IsVisited() == NO) {
			numSubNetwork++;
			Visit(i);				// 

// 			// for debugging
//  		cout << i << endl;
		}
	}

	snary = new SubNetwork[numSubNetwork];
	for (i = 0; i < numSubNetwork; i++) {
		snary[i].CopySegmentList(slist[i], i+1);
		snary[i].MakeEndPointsData();
	}
}

void GridBox::Visit		// ƻʬ i ˬ
(
	int i				// ƻʬֹ
)
{
	// i ˬ줿եåΩƤ
	seg[i].Visited();
// 	// i ʬϤֹ (numSubNetwork) Ϳ
// 	seg[i].RecSubNum(numSubNetwork);
	// i  slist ɲä
	slist[numSubNetwork - 1].Append(seg[i]);

	int j;

	// ƻʬ i ȤĤʤäƤƻʬ j õ
	for (j = 0; j < numSegment; j++) {
		// ä
		if (seg[j].IsVisited() == NO && adjacent[i][j] == YES) {
			Visit(j);

// 			// for debugging
// 			cout << j << endl;
		}
	}
}

void GridBox::WriteData			// ǡϤ
(
	void						// ̵
)
{
	int i;
	for (i = 0; i < numSubNetwork; i++) {
		KhString fname(snf2);
		// ʬֹϥե̾դ
		ostrstream os;
		os << i+1 << ends;
		fname += os.str();
		fname += '.';
		// ĥҤ snf2
		fname += "snf2";
		snary[i].WriteData(fname, comment, dataFormatName, 
						   coordinateSystem, mapNumber, 
						   referenceCoordinates, verticesOfTheMap,
						   numSubNetwork);
	}
}

void usage(const KhString& command)
{
  cerr
  << "\n" << command << " produces sub-network format data V.2.\n"
  << "usage: " << command << " [options] [pfFileName] [snfFileName]\n"
  << "  options: \n"
  << "    -h  show this help message\n"
  << "    -v  show version number\n"
  << "  pfFileName:   plain format data V.1 or V.2\n"
  << "  snfFileName:  sub-network format data V.2\n"
  << "  If \"pfFileName\" and \"snfFileName\" are given in the command line, \n"
  << "  the input data are read in from the file.\n"
  << "  Otherwise, the input data are read in from STDIN\n"
  << "  with giving prompting messages.\n" << endl;
  exit(1);
}

void version(void)
{
	cerr << "\nThis is makeSubNetwork, version 2.0\n"
		 << "developed by Yutaka ICHIKAWA, Kyoto Univ.\n" << endl;
}

int main						// ᥤץ
(
	int argc,
 	char** argv
)
{

	KhString command = nopath(argv[0]);

  	// optstring ǡץȤƵʸꤷޤ
	char *optstring = "hv";

	int c;
	while((c = getopt(argc, argv, optstring)) != EOF)
	{
    	// getopt ϲϤץʸ֤ޤ
		switch (c) {
		  case 'v':
			version();
			break;
		  case 'h':
			// ץʸ h ֤Ƥν
			// fall through
		  default:
			usage(command);
		}
	}

	// argc ˤ, ޥ̾ȰθĿޤĤʤ
	// Ȥargc ˤ 1 ޤ

	if (argc != 1 && argc != 3)
	{
		//  command ǤϡθĿ2Ĥޤ0ĤǤ
		usage(command);
	}

	// ϥե̾
	char in[256], out[256];
	if (argc == 1) {
		cout << "# plain format file (V.1,2) : ";
		cin >> in;
		cout << "# output file : ";
		cin >> out;
	}
	else {
		istrstream istri(argv[1]);
		istri >> in;
		istrstream istro(argv[2]);
		istro >> out;
	}

	GridBox gb(in, out);

	//  DS [Data] seg ɤ߹
	gb.ReadDataSection();

	// ³
	gb.MakeAdjacent();

	// ʬϤ
	gb.MakeSubNetwork();

	// ǡν
	gb.WriteData();

	return 0;
}
