#! /usr/local/bin/perl
#
# @(#) plain format V.1 or V.2 βƻ֥ǡåȤ
#      gnuplot ɽ뤿Υǡùץ
#
# $RCSfile: preRiverPlot.pl,v $  $Revision: 1.3 $
# $Date: 1997/09/27 07:26:52 $  by KyotoHydro
#

# ƻʬϢΥǡδ֤˶Ԥޤ
# gnuplot 褷䤹뤿Ѥޤ
#
# ̤ΥǡɸϤ˽񤭽Фޤ
#
# 
#      $0 testStream.data > testStreamGnuplot.data
#
#       testStream.data  plain format V1 or V2 
#      ƻ֥ǡå
#
# ̤ɽˤϡ
#
#    % gnuplot
#    gnuplot> plot "testStreamGnuplot.data" w l
#
# ȤƤ

#  $ARGV[0], $ARGV[1], ... $ARGV[$#ARGV]

sub usage {
    if ($0 =~ m#.*/([^/]*)$#) {
        $0 = $1;
    }
    print STDERR "usage: $0 plainFormatV1or2FileName\n";
    exit 1;
}

sub version {
	print STDERR "This is preRiverPlot ver. 2\n";
	exit 1;
}

sub get_format_name ($) {
  my ($str) = @_;
  while (<$str>)
  {
    if (/^#/)
    {
      next;
    }
    chomp;
    last;
  }
  $_;
}

# h, v ץȤ (added by Yutaka ICHIKAWA, 971212)
use Getopt::Std;
getopts('hv');

if ($opt_h == 1) { &usage; }
if ($opt_v == 1) { &version; }

if ($#ARGV != 0) { &usage; }

$minamiFile = $ARGV[0];

open(IN, $minamiFile) || die "$minamiFile: $!";

$fomatCheck = 0;

while (<IN>)
{
  if (/^\[Data Format Name\]/) {
    $formatName = get_format_name(IN);
    if ($formatName !~ /^plain format V.2$/ && 
		$formatName !~ /^sub-network format V.2$/) {
     print "Format: $formatName\n";
      print "Format should be \"plain format V.1 or V.2\"\n";
      exit 1;
    }
    $formatCheck = 1;
    next;
  }
  if (/^#/)
  {
    next;
  }
  if (/^\[Data\]/)
  {
    if ($formatCheck == 0) {
      print "Format should be \"plain format V.1 or V.2\"\n";
      exit 1;
    }
    last;
  }
}

print <<"MESSAGEEND";
# @(#) gnuplot Ȥä3ƻ֥ǡ
#
# produced from $minamiFile by preRiverPlot.pl

MESSAGEEND

$lastTag = 1;
$lastSegNo = -999;
while (<IN>)
{
  if (/^#/)
  {
    next;
  }
  @list = split(' ', $_);
# ŤǤΤȤ
#  print $list[3], " ", $list[4], " ",
#        $list[5], "\n";
  print $list[5], " ", $list[6], " ",
        $list[7], "\n";
  $presentTag = $list[2];
  $presentSegNo = $list[3];
  if ($lastTag == 0 && $presentTag != 0)
  {
    print "\n";
  }
  elsif ($lastTag != 0 && $presentTag != 0 && $lastSegNo == $presentSegNo)
  {
    print "\n";
  }
  $lastTag = $presentTag;
  $lastSegNo = $presentSegNo;
}

## Local Variables: ***
## mode: Text ***
## End: ***


